/* 
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

import QtQuick
import QtQuick.Controls
import Mirai

CheckBox {
	id: control
	property alias textComponent: text

	contentItem: Text {
		id: text
		text: control.text
        color: MiraiColorPalette.text
        verticalAlignment: Text.AlignVCenter
        leftPadding: control.indicator.width + control.spacing
	}
	
	indicator: Rectangle {
		x: control.leftPadding
    	y: control.topPadding + (control.availableHeight - height) / 2
		implicitWidth: 12
		implicitHeight: 12
		radius: 999
		color: control.checked ? colorPalette.selected.palette.green : colorPalette.selected.text


		Rectangle {
			anchors.horizontalCenter: parent.horizontalCenter
			anchors.verticalCenter: parent.verticalCenter
			implicitWidth: 10
			implicitHeight: 10
			radius: 999
			color: control.checked ? colorPalette.selected.palette.green : colorPalette.selected.fieldBackground
		}
	}
}
