/* 
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

import QtQuick
import QtQuick.Window
import QtQuick.Layouts
import Mirai

RowLayout {
	id: control
	property taskItem task

	function getFormatedText() {
		if (task?.time && task.time != "") {
			return `<font color=\"${colorPalette.selected.palette.overlay1}\">${task.time} \></font> ${task.text}`
		}
		return task.text
	}

	AppCheckbox {
		id: checkbox
		text: control.getFormatedText()
		checked: task.state === 'DONE'
		textComponent.color: task.date < internal.todayDate ? colorPalette.selected.palette.pink
			// : task.date === internal.todayDate ? colorPalette.selected.palette.sapphire
			: colorPalette.selected.text
		onClicked: {
			backend.updateTodo(index, modelData.state === 'DONE' ? "TODO" : "DONE", modelData.text, modelData.date)
		}
	}

	Repeater {
		model: task.tags
		Tag {
			Layout.alignment: Qt.AlignVCenter
			text: modelData
			backgroundColor: colorPalette.selected.fieldBackground
			textColor: colorPalette.selected.palette.sapphire
		}
	}

	
}
